#!/usr/bin/env python
# -*- coding: utf-8 -*-

# An ES Tools replacement for CS:S by fratacos
# Version 0.63

#[Added]
#credits, setentmodel

#[Fixed]
#est_knifeonly bug that slot 4 returned empty list instead of weapon_none
#est_help to use standard message.
#est_removeweapon to use last weapon when one of the targets is active weapon
#est_rocket to add some effects
#est_restrict to remove restricted weapon at hand
#est_drug to use null as empty status string
#these functions for optimization: rocket, physpush, pushto, entteleport, entpushto, setmodel and getplayerdistance
#some code styles
#static lists to tuples

#[Known Issues]
#endround and rocket are incomplete
#death/restriction functions are fakes
#All commands are in lower cases (this is a limitation of EventScripts)

import es
import spe
import gamethread
import playerlib
import time
import random
import os
import math
import operator

hooked_event_var = 0
round_count = 0
round_interval = 0
timer = 0
gametime = 0
curtimed = 0
starttime = time.time()
regclientcmd_list = []
restrict_list = {}
modplayerweapon_list = {}
modweapon_list = {}
weaponmod_list = {}
modified_deaths = 0
deaths_list = {}
regeventblock_list = {}
rocket_list = {}
file_list = {}
file_handle = 0
escort_list = {}
bought_list = {}
sayhook_list = {}
getchat_list = {}
entname_list = {}
cs_player_manager = 0
count_rescued = 0
thetrigger = 0
allweapons = ("weapon_ak47", "weapon_aug", "weapon_awp", "weapon_c4", "weapon_deagle", "weapon_elite", "weapon_famas", "weapon_fiveseven", "weapon_flashbang", "weapon_g3sg1", "weapon_galil", "weapon_glock", "weapon_hegrenade", "weapon_knife", "weapon_m249", "weapon_m3", "weapon_m4a1", "weapon_mac10", "weapon_mp5navy", "weapon_p228", "weapon_p90", "weapon_scout", "weapon_sg550", "weapon_sg552", "weapon_smokegrenade", "weapon_tmp", "weapon_ump45", "weapon_usp", "weapon_xm1014")
allprimary = ("weapon_ak47", "weapon_aug", "weapon_awp", "weapon_famas", "weapon_g3sg1", "weapon_galil", "weapon_m249", "weapon_m3", "weapon_m4a1", "weapon_mac10", "weapon_mp5navy", "weapon_p90", "weapon_scout", "weapon_sg550", "weapon_sg552", "weapon_tmp", "weapon_ump45", "weapon_xm1014")
allsecondary = ("weapon_deagle", "weapon_elite", "weapon_fiveseven", "weapon_glock", "weapon_p228", "weapon_usp")
ammo_list = { "weapon_p228":"009", "weapon_deagle":"001", "weapon_m4a1":"003", "weapon_tmp":"006", "weapon_aug":"002", "weapon_smokegrenade":"013", "weapon_mac10":"008", "weapon_m3":"007", "weapon_ak47":"002", "weapon_m249":"004", "weapon_fiveseven":"010", "weapon_xm1014":"007", "weapon_flashbang":"012", "weapon_glock":"006", "weapon_p90":"010", "weapon_usp":"008", "weapon_ump45":"008", "weapon_awp":"005", "weapon_scout":"002", "weapon_elite":"006", "weapon_c4":None, "weapon_famas":"003", "weapon_galil":"003", "weapon_hegrenade":"011", "weapon_mp5navy":"006", "weapon_knife":None, "weapon_g3sg1":"002", "weapon_sg550":"003", "weapon_sg552":"003", }
allflags = ("gamedll", "protected", "sponly", "notify", "cheat", "userinfo", "unlogged", "replicated")
pyfilter = ("#alive", "#all", "#bot", "#ct", "#dead", "#human", "#spec", "#t", "#un")
filter_table = (("t","#t"), ("c","#ct"), ("3","#ct"), ("2","#t"), ("s","#spec"), ("1","#spec"), ("u","#un"), ("h","#human"), ("b","#bot"), ("l","#alive"), ("a","#all"), ("d","#dead"))
weaponmod_default = {"recoil":0, "damage0":0, "damage1":0, "damage2":0, "damage3":0, "damage4":0, "damage5":0, "damage6":0, "damage7":0, "damageaction":"+", "punchback":0, "speed":1.0, "auto":0}

def load():
	es.addons.registerClientCommandFilter(clientcommandfilter)
	es.addons.registerTickListener(ticklistener)
	es.addons.registerSayFilter(sayfilter)
	spe.registerPreHook("player_disconnect", pre_player_disconnect)
	spe.registerPreHook("player_hurt", pre_player_hurt)
	spe.registerPreHook("weapon_fire", pre_weapon_fire)
	spe.registerPreHook("item_pickup", pre_item_pickup)

def unload():
	spe.unregisterPreHook("item_pickup", pre_item_pickup)
	spe.unregisterPreHook("weapon_fire", pre_weapon_fire)
	spe.unregisterPreHook("player_hurt", pre_player_hurt)
	spe.unregisterPreHook("player_disconnect", pre_player_disconnect)
	es.addons.unregisterSayFilter(sayfilter)
	es.addons.unregisterTickListener(ticklistener)
	es.addons.unregisterClientCommandFilter(clientcommandfilter)

def adddownload(param):
	es.stringtable("downloadables", param)
def armor(users, param, value):
	v = int(value)
	for userid in getusers(users):
		if param in ("+", "-"):
			now = es.getplayerprop(userid, "CCSPlayer.m_ArmorValue")
			if param == "+":
				now += v
			if param == "-":
				now -= v
			v = now
		if param in ("=", "+", "-"):
			es.setplayerprop(userid, "CCSPlayer.m_ArmorValue", v)
def armoradd(users, value):
	armor(users, "+", value)
def ban(users, time, reason = ""):
	flag = 0
	if reason == "":
		flag = 1
	for userid in getusers(users):
		if flag:
			es.ServerCommand("banid %s %s kick" % (time, userid))
		else:
			es.ServerCommand("banid %s %s" % (time, userid))
			es.ServerCommand("kickid %s %s" % (userid, reason))
def burn(users, time = 0):
	t = int(time)
	trigger = gettrigger()
	for userid in getusers(users):
		index = es.getindexfromhandle(es.getplayerhandle(userid))
		es.entitysetvalue(index, "targetname", index)
		if t != 0:
			es.fire(trigger, index, "IgniteLifetime", t)
		else:
			es.fire(trigger, index, "Ignite")
def cash(users, param, value):
	v = int(value)
	for userid in getusers(users):
		if param in "+-":
			now = es.getplayerprop(userid, "CCSPlayer.m_iAccount")
			if param == "+":
				now += v
			if param == "-":
				now -= v
			v = now
		if param in "=+-":
			es.setplayerprop(userid, "CCSPlayer.m_iAccount", v)
def cashadd(users, value):
	cash(users, "+", value)
def cexec(users, command):
	for userid in getusers(users):
		es.ServerCommand("es_xsexec %s %s" % (userid, command))
def closefile(fileid):
	global file_list
	id = int(fileid)
	if not id in file_list:
		return
	del file_list[id]
def countlines(fileid):
	global file_list
	id = int(fileid)
	if not id in file_list:
		return
	no = 0
	for line in file_list[id][2]:
		no += 1
	return no
def csay(users, text):
	es.usermsg("create", "centermsg", "TextMsg")
	es.usermsg("write", "byte", "centermsg", 4)
	es.usermsg("write", "string", "centermsg", unicode(text))
	for userid in getusers(users):
		es.usermsg("send", "centermsg", userid)
	es.usermsg("delete", "centermsg")
def curtime_init():
	global timer, gametime
	timer = time.time()
	temp = es.createentity("env_particlesmokegrenade")
	gametime = es.getindexprop(temp, "ParticleSmokeGrenade.m_flSpawnTime")
	es.server.insertcmd("es_xremove %i" % temp)
def curtime():
	global timer, gametime, curtimed
	if curtimed == 0:
		return gametime
	if timer == 0:
		curtime_init()
		return gametime
	return gametime + time.time() - timer
def cvaraddflag(cvar, gamedll, protected, sponly, notify, cheat, userinfo, unlogged, replicated):
	global allflags
	data = (gamedll, protected, sponly, notify, cheat, userinfo, unlogged, replicated)
	count = 0
	while count < 8:
		if int(data[count]) == 1:
			es.flags("add", allflags[count], cvar)
		count += 1
def cvardelflag(cvar, gamedll, protected, sponly, notify, cheat, userinfo, unlogged, replicated):
	global allflags
	data = (gamedll, protected, sponly, notify, cheat, userinfo, unlogged, replicated)
	count = 0
	while count < 8:
		if int(data[count]) == 1:
			es.flags("remove", allflags[count], cvar)
		count += 1
def damage(source, target, value):
	targets = getusers(target)
	gamethread.delayed(0.1, damage_delayed, targets)
	if str(source) == "0":
		for userid in targets:
			source = userid
			index = es.getindexfromhandle(es.getplayerhandle(userid))
			es.entitysetvalue(index, "targetname", "damagetarget")
			index = es.createentity("point_hurt")
			es.entitysetvalue(index, "damage", value)
			es.entitysetvalue(index, "damagetype", 32)
			es.entitysetvalue(index, "targetname", index)
			es.fire(source, index, "addoutput", "DamageTarget damagetarget")
			es.fire(source, index, "Hurt")
			es.fire(source, index, "Kill")
	else:
		for userid in getusers(source):
			break
		else:
			return
		source = userid
		for userid in targets:
			index = es.getindexfromhandle(es.getplayerhandle(userid))
			es.entitysetvalue(index, "targetname", "damagetarget")
		index = es.createentity("point_hurt")
		es.entitysetvalue(index, "damage", value)
		es.entitysetvalue(index, "damagetype", 32)
		es.entitysetvalue(index, "targetname", index)
		es.entitysetvalue(index, "classname", getgun(source))
		es.fire(source, index, "addoutput", "DamageTarget damagetarget")
		es.fire(source, index, "Hurt")
		es.fire(source, index, "Kill")
def damage_delayed(targets):
	for userid in targets:
		index = es.getindexfromhandle(es.getplayerhandle(userid))
		es.entitysetvalue(index, "targetname", "")
def deafen(users, total, percent, fadeout, fadeback):
	for userid in getusers(users):
		es.fadevolume(userid, percent, fadeout, total, fadeback)
def deathadd(users, value):
	deaths(users, "+", value)
def deaths(users, param, v):
	global deaths_list
	global modified_deaths
	global cs_player_manager
	if not param in ("=", "+", "-"):
		return
	if modified_deaths == 0:
		modified_deaths = 1
		for userid in es.getUseridList():
			deaths_list[userid] = es.getindexprop(cs_player_manager, "CPlayerResource.m_iDeaths.%.3d" % es.getindexfromhandle(es.getplayerhandle(userid)))
	value = int(v)
	for userid in getusers(users):
		if param == "=":
			deaths_list[userid] = value
		if param == "+":
			deaths_list[userid] += value
		if param == "-":
			deaths_list[userid] -= value
def deathset(users, value):
	deaths(users, "=", value)
def dissolve(param):
	trigger = gettrigger()
	index = es.createentity("env_entity_dissolver", trigger)
	es.entitysetvalue(index, "target", param)
	es.entitysetvalue(index, "magnitude", 1)
	es.entitysetvalue(index, "dissolvetype", 3)
	es.spawnentity(index)
	es.fire(trigger, trigger, "Dissolve")
	es.fire(trigger, trigger, "Kill")
def deleteragdolls(users = 0):
	if str(users) == "0":
		es.fire(gettrigger(), "cs_ragdoll", "Kill", 0.15)
		return
	handles = []
	for userid in getusers(users):
		handles.append(es.getplayerhandle(userid))
	ragdolls = es.createentitylist("cs_ragdoll")
	for index in ragdolls:
		if es.getindexprop(index, "CCSRagdoll.m_hPlayer") in handles:
			es.setentityname(index, "theragdoll")	
	es.fire(gettrigger(), "theragdoll", "Kill", 0.15)
def dropweapon(users, param):
	global allweapons
	for userid in getusers(users):
		name = getweaponinfo(userid, param)
		for item in name:
			if item in allweapons:
				spe.dropWeapon(userid, item)
def drug(users, time = -1):
	t = int(time)
	for userid in getusers(users):
		if t != 0:
			es.cexec(userid, "r_screenoverlay Effects/tp_eyefx/tp_eyefx.vmt")
		if t >= 0:
			gamethread.delayed(t, es.cexec, (userid, "r_screenoverlay null"))
def drunk(users, time = -1):
	global round_count
	t = int(time)
	drunk_loop(0, t, getusers(users), 90, 0, int(round_count))
def drunk_loop(count, time, users, fov, ang, round):
	global round_count
	global round_interval
	if (round != round_count) or (time >= 0 and count / 5 > time):
		for userid in users:
			player = playerlib.getPlayer(userid)
			angle = player.getViewAngle()
			es.setang(userid, angle[0], angle[1], 0)
			es.setplayerprop(userid, "CBasePlayer.m_iFOV", 90)
		return
	flag = 0
	for userid in users:
		dead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
		if dead:
			player = playerlib.getPlayer(userid)
			angle = player.getViewAngle()
			es.setang(userid, angle[0], angle[1], 0)
			es.setplayerprop(userid, "CBasePlayer.m_iFOV", 90)
			continue
		flag = 1
		ang += (-15, -10, 10, 15)[random.randint(0, 3)]
		if ang < -60: ang = -60
		if ang > 60: ang = 60
		player = playerlib.getPlayer(userid)
		angle = player.getViewAngle()
		es.setang(userid, angle[0], angle[1], ang)
		fov += (-15, -10, -5, 5, 10, 15)[random.randint(0, 5)]
		if fov < 30: fov = 30
		if fov > 150: fov = 150
		es.setplayerprop(userid, "CBasePlayer.m_iFOV", fov)
	if flag:
		gamethread.delayed(0.2, drunk_loop, (count + 1, time, users, fov, ang, round))
def endround(time, reason):
	t = int(time)
	r = int(reason)
	if not (0 < r and r < 17):
		return
	data = [["#Target_Bombed", 2], ["#VIP_Escaped", 3], ["#VIP_Assassinated", 2], ["#Terrorists_Escaped", 2], ["#CTs_PreventEscape", 3], ["#Escaping_Terrorists_Neutralized", 3], ["#Bomb_Defused", 3], ["#CTs_Win", 3], ["#Terrorists_Win", 2], ["#Round_Draw", 0], ["#All_Hostages_Rescued", 3], ["#Target_Saved", 3], ["#Hostages_Not_Rescued", 2], ["#Terrorists_Not_Escaped", 3], ["#VIP_Not_Escaped", 2], ["#Game_Commencing", 0]]
	winner = data[r - 1][1]
	text = data[r - 1][0]
	es.event("initialize", "round_end")
	es.event("setint", "round_end", "winner", winner)
	es.event("setint", "round_end", "reason", r)
	es.event("setstring", "round_end", "message", text)
	es.event("fire", "round_end")
	gamethread.delayed(t, endround_delayed1, (t, text))
	gamethread.delayed(t + 0.20, endround_delayed2, (t, text))
def endround_delayed1(t, text):
	es.flags("remove", "cheat", "endround")
	es.ServerCommand("endround")
def endround_delayed2(t, text):
	es.flags("add", "cheat", "endround")
	if t >= 2:
		es.centermsg("")
	else:
		es.centermsg(text)
def entphyspush(index, x, y, z):
	es.fire(gettrigger(), "prop_physics_multiplayer", "Wake")
	gamethread.delayed(0.1, es.physics, ("active", "setvelocity", index, "%f,%f,%f" % (float(x), float(y), float(z))))
def entpushto(index, x, y, z, force):
	source = es.getindexprop(index, "CBaseEntity.m_vecOrigin").split(",")
	base = (float(x) - float(source[0]), float(y) - float(source[1]), float(z) - float(source[2]))
	f = float(force)
	es.fire(gettrigger(), "prop_physics_multiplayer", "Wake")
	gamethread.delayed(0.1, es.physics, ("active", "applyforce", index, "%f,%f,%f" % (base[0] * f, base[1] * f, base[2] * f, )))
def entteleport(index, x, y, z):
	es.setentityname(index, "theentity")
	es.entitysetvalue(index, "origin", str(x) + "," + str(y) + "," + str(z))
def extinguish(users):
	trigger = gettrigger()
	for userid in getusers(users):
		index = es.getindexfromhandle(es.getplayerhandle(userid))
		es.entitysetvalue(index, "targetname", index)
		es.fire(trigger, index, "IgniteLifetime", 0)
def fade(users, type, fadetime, totaltime, r, g, b, a):
	t = int(type)
	if t == 1:
		type = 2
	elif t == 0:
		type = 1
	else:
		type = 8 + 16
	es.usermsg("create", "fade", "Fade")
	es.usermsg("write", "short", "fade", float(fadetime) * 1000)
	es.usermsg("write", "short", "fade", float(totaltime) * 1000)
	es.usermsg("write", "short", "fade", int(type))
	es.usermsg("write", "byte", "fade", int(r))
	es.usermsg("write", "byte", "fade", int(g))
	es.usermsg("write", "byte", "fade", int(b))
	es.usermsg("write", "byte", "fade", int(a))
	for userid in getusers(users):
		es.usermsg("send", "fade", userid)
	es.usermsg("delete", "fade")
def fileexists(path):
	test = os.getcwd() + "/cstrike/" + path
	if not os.path.exists(test): return 0
	if not os.path.isabs(test): return -1
	if not os.path.isfile(test): return -1
	if os.path.islink(test): return -1
	return 1
def freeze(users, param = 1):
	# we can't bit operate directly because movetype isn't always positive
	for userid in getusers(users):
		movetype = es.getplayerprop(userid, "CBaseEntity.movetype")
		if not movetype:
			continue
		if str(param) == "1":
			if movetype & 2:
				es.setplayerprop(userid, "CBaseEntity.movetype", movetype - 2)
		else:
			if not movetype & 2:
				es.setplayerprop(userid, "CBaseEntity.movetype", movetype + 2)
def getammo(users, param):
	global ammo_list
	for userid in getusers(users):
		info = getweaponinfo(userid, param)
		for name in info:
			no = ammo_list[name]
			return es.getplayerprop(userid, "CBasePlayer.localdata.m_iAmmo.%s" % no)
	return None
def getarmor(users):
	for userid in getusers(users):
		return es.getplayerprop(userid, "CCSPlayer.m_ArmorValue")
	return None
def getchat(users):
	global getchat_list
	for userid in getusers(users):
		id = int(userid)
		if id in getchat_list:
			return getchat_list[id]
def getclipammo(users, param):
	for userid in getusers(users):
		info = getweaponinfo(userid, param, 1)
		if info == []:
			continue
		for index in info:
			return es.getindexprop(index, "CBaseCombatWeapon.LocalWeaponData.m_iClip1")
	return None
def getdeaths(users):
	global deaths_list
	global modified_deaths
	global cs_player_manager
	if modified_deaths != 0:
		for userid in getusers(users):
			return deaths_list[userid]
	else:
		for userid in getusers(users):
			return es.getindexprop(cs_player_manager, "CPlayerResource.m_iDeaths.%.3d" % es.getindexfromhandle(es.getplayerhandle(userid)))
	return None
def getentclassname(index):
	return es.entitygetvalue(index, "classname")
def getentname(index):
	global entname_list
	if index in entname_list:
		return entname_list[index]
	return ""
def getescort(users):
	global escort_list
	for userid in getusers(users):
		return escort_list[userid]
	return 0
def geteventinfo(param):
	global hooked_event_var
	if hooked_event_var != 0 and param in hooked_event_var:
		return hooked_event_var[param]
def geteyecoord(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).getEyeLocation()
def getfb(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).getFB()
	return None
def getgravity(users):
	for userid in getusers(users):
		index = es.getindexfromhandle(es.getplayerhandle(userid))
		return es.entitygetvalue(index, "gravity")
	return None
def getgun(users):
	for userid in getusers(users):
		handle = es.getplayerprop(userid, "CBaseCombatCharacter.m_hActiveWeapon")
		index = es.getindexfromhandle(handle)
		return es.entitygetvalue(index, "classname")
	return "weapon_none"
def gethe(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).getHE()
	return None
def gethealth(users):
	for userid in getusers(users):
		return es.getplayerprop(userid, "CBasePlayer.m_iHealth")
	return None
def getindex(users):
	for userid in getusers(users):
		return es.getindexfromhandle(es.getplayerhandle(userid))
	return None
def getip(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).address
def getkills(users):
	global cs_player_manager
	for userid in getusers(users):
		return es.getindexprop(cs_player_manager, "CPlayerResource.m_iScore.%.3d" % es.getindexfromhandle(es.getplayerhandle(userid)))
	return None
def getline(fileid, lineno):
	global file_list
	id = int(fileid)
	if not id in file_list: return
	theno = int(lineno)
	no = 0
	for line in file_list[id][2]:
		no += 1
		if no == theno:
			break
	return line
def getname(users):
	for userid in getusers(users):
		return es.getplayername(userid)
	return None
def getplayerdistance(target1, target2):
	for t1 in getusers(target1):
		break
	else:
		return
	for t2 in getusers(target2):
		break
	else:
		return
	vec1 = [float(x) for x in es.getplayerprop(t1, "CBaseEntity.m_vecOrigin").split(",")]
	vec2 = [float(x) for x in es.getplayerprop(t2, "CBaseEntity.m_vecOrigin").split(",")]
	vec = map(operator.sub, vec1, vec2)
	distance = (vec[0]**2 + vec[1]**2 + vec[2]**2)**0.5
	azimuth = math.degrees(math.atan2(vec1[1] - vec2[1], vec1[0] - vec2[0])) + 180
	elevation = math.degrees(math.atan2(vec1[2] - vec2[2], distance)) + 360
	return distance, azimuth, elevation
def getprimary(users):
	for userid in getusers(users):
		return getweaponinfo(userid, 1)[0]
def getsecondary(users):
	for userid in getusers(users):
		return getweaponinfo(userid, 2)[0]
def getsg(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).getSG()
def getslot(users, param):
	if not str(param) in ("1", "2", "3", "4"):
		return
	for userid in getusers(users):
		return getweaponinfo(userid, param)[0]
def getsteam(users):
	for userid in getusers(users):
		return es.getplayersteamid(userid)
	return None
def getteam(users):
	for userid in getusers(users):
		return es.getplayerprop(userid, "CBaseEntity.m_iTeamNum")
	return None
def getuserid(users):
	for userid in getusers(users):
		return userid
	return None
def getviewangle(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).getViewAngle()
def getviewprop(users):
	for userid in getusers(users):
		break
	else:
		return
	index = es.getindexfromhandle(es.getplayerhandle(userid))
	es.entitysetvalue(index, "targetname", index)
	es.fire(userid, "!picker", "addoutput", "targetname lookingat")
	for index in es.createentitylist():
 		if es.entitygetvalue(index, "targetname") == "lookingat":
			es.entitysetvalue(index, "targetname", "")
			return index
def getviewplayer(users):
	for userid in getusers(users):
		break
	else:
		return
	es.fire(userid, "!picker", "addoutput", "targetname lookingat")
	for index in es.createentitylist():
 		if es.entitygetvalue(index, "targetname") == "lookingat":
			es.entitysetvalue(index, "targetname", "")
			if es.entitygetvalue(index, "classname") == "player":
				for userid in es.getUseridList():
					if index == es.getindexfromhandle(es.getplayerhandle(userid)):
						return userid
			return 0
	return 0
def getweaponindex(users, param):
	for userid in getusers(users):
		info = getweaponinfo(userid, param, 1)
		if info == []:
			return None
		return info[0]
def give(users, param):
	for userid in getusers(users):
		es.ServerCommand("es_xgive %s %s" % (userid, param))
def god(users, param = 1):
	for userid in getusers(users):
		dead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
		if not dead:
			if str(param) == "1":
				es.setplayerprop(userid, "CBasePlayer.m_lifeState", 0)
			else:
				es.setplayerprop(userid, "CBasePlayer.m_lifeState", 512)
def hasdefuser(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).hasDefuser()
	return 0
def hashelmet(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).hasHelmet()
	return 0
def haskevlar(users):
	for userid in getusers(users):
		if es.getplayerprop(userid, "CCSPlayer.m_ArmorValue") > 0:
			return 1
		else:
			return 0
	return 0
def health(users, param, value = 0):
	v = int(value)
	if v == 0 and str(param) not in ("=", "+", "-"):
		v = int(param)
		param = "="
	flag = 0
	for userid in getusers(users):
		vv = v
		if param in ("+", "-"):
			now = es.getplayerprop(userid, "CBasePlayer.m_iHealth")
			if now == None:
				continue
			vv = now
			if param == "+":
				vv += v
			if param == "-":
				vv -= v
		if param in ("=", "+", "-"):
			es.setplayerprop(userid, "CBasePlayer.m_iHealth", vv)
			es.setplayerprop(userid, "CBasePlayer.m_iMaxHealth", vv)
def healthadd(users, value):
	health(users, "+", value)
def hsay(users, text):
	es.usermsg("create", "hudhint", "HintText")
	es.usermsg("write", "string", "hudhint", unicode(text))
	for userid in getusers(users):
		es.usermsg("send", "hudhint", userid)
	es.usermsg("delete", "hudhint")
def isalive(users):
	for userid in getusers(users):
		if es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
			return 0
		else:
			return 1
def isalpha(param):
	if param.isalpha():
		return 1
	else:
		return 0
def isbomber(users):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		if player.hasC4():
			return 1
		else:
			return 0
def isnumeric(param):
	if param.startswith("-"):
		param = param[1:]
	param = param.replace(".", "")
	if param.isdigit():
		return 1
	else:
		return 0
def isonly(param, checker):
	for item in param:
		if not item in checker:
			return 0
	return 1
def jetpack(users, param):
	p = int(param)
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		player.jetpack(p)
def kick(users, reason = ""):
	flag = 0
	if reason == "":
		flag = 1
	for userid in getusers(users):
		if flag:
			es.ServerCommand("kickid %s" % userid)
		else:
			es.ServerCommand("kickid %s %s" % (userid, reason))
def killadd(users, v):
	kills(users, "+", v)
def kills(users, param, v):
	value = int(v)
	if param == "+":
		apply = value
	if param == "-":
		apply = -value
	if not param == "=":
		trigger = gettrigger()
		index = es.createentity("game_score")
		es.setentityname(index, index)
		es.fire(trigger, index, "addoutput", "spawnflags 1")
		es.fire(trigger, index, "addoutput", "points %d" % apply)
	for userid in getusers(users):
		if param == "=":
			apply = value - getkills(userid)
			index = es.createentity("game_score")
			es.setentityname(index, index)
			es.fire(userid, index, "addoutput", "spawnflags 1")
			es.fire(userid, index, "addoutput", "points %d" % apply)
		es.fire(userid, index, "ApplyScore")
		if param == "=":
			es.fire(userid, index, "Kill")
	if not param == "=":
		es.fire(trigger, index, "Kill")
def killset(users, v):
	kills(users, "=", v)
def knifeonly(users):
	for userid in getusers(users):
		if getweaponinfo(userid, 1) == ["weapon_none"] and getweaponinfo(userid, 2) == ["weapon_none"] and getweaponinfo(userid, 3) == ["weapon_knife"] and getweaponinfo(userid, 4) == ["weapon_none"]:
			return 1
		else:
			return 0
def lightstyle(style, index):
	es.lightstyle(style, index)
def loadweaponmod(filename):
	if es.ServerVar("est_enable_weapon_mods") == 0:
		return
	global allweapons
	global weaponmod_list
	global weaponmod_default
	path = "addons/est/" + filename
	test = os.getcwd() + "/cstrike/" + path
	if fileexists(path) != 1:
		return
	item = None
	status = 0
	file = open(test)
	try:
		for line in file:
			line = line.replace("\r", "")
			line = line.replace("\n", "")
			line = line.replace("\t", "")
			line = line.replace(" ", "")
			if line == "" or line.startswith("//"):
				continue
			if "{" in line:
				status += 1
				if status != 2:
					continue
				item = None
				temp = line.split('"')
				if len(temp) != 3:
					continue
				tempitem = "weapon_" + temp[1]
				if not tempitem in allweapons:
					continue
				item = tempitem
				weaponmod_list[item] = weaponmod_default
				continue
			if "}" in line and status > 0:
				status -= 1
				continue
			if status == 2 and item != None:
				temp = line.split('"')
				if len(temp) != 3:
					continue
				param = temp[0]
				value = temp[1]
				temp_dic = weaponmod_list[item]
				temp_dic[param] = value
	finally:
		if file: file.close()
def loop(variable, users, command):
	for userid in getusers(users):
		es.ServerCommand("es_set %s %s" % (variable, userid))
		es.ServerCommand(command)
def modplayerweapon(users, param, value):
	global allweapons
	global modplayerweapon_list
	v = int(value)
	if not param in allweapons:
		return
	for userid in getusers(users):
		id = int(userid)
		if v == -1:
			if not id in modplayerweapon_list:
				continue
			mods = modplayerweapon_list[id]
			for item in mods:
				if item[0] == param:
					modplayerweapon_list[id].remove(item)
					break
		else:
			if not id in modplayerweapon_list:
				modplayerweapon_list[id] = []
			modplayerweapon_list[id].append([param, v])
def modweapon(param, value):
	global allweapons
	if not param in allweapons:
		return
	global modweapon_list
	v = int(value)
	if v == -1:
		if param in modweapon_list:
			del modweapon_list[param]
	else:
		modweapon_list[param] = v
def motd(users, title, type, msg):
	data = { "title":title, "type":type, "msg":msg }
	es.usermsg('create', 'panel', 'VGUIMenu')
	es.usermsg('write', 'string', 'panel', "info")
	es.usermsg('write', 'byte', 'panel', 1)
	es.usermsg('write', 'byte', 'panel', len(data))
	for item in data:
		es.usermsg('write', 'string', 'panel', item)
		es.usermsg('write', 'string', 'panel', data[item])
	for userid in getusers(users):
		es.usermsg('send', 'panel', userid)
	es.usermsg('delete', 'panel')
def motd_f(users, title, command, path):
	motd(users, unicode(title), "3", path)
def motd_t(users, title, command, text):
	motd(users, unicode(title), "0", unicode(text))
def motd_w(users, title, command, url):
	motd(users, unicode(title), "2", url)
def msg(users, value):
	for userid in getusers(users):
		es.tell(userid, "#multi", value)
def name(users, value):
	for userid in getusers(users):
		if es.getplayersteamid(userid) == "BOT":
			es.botsetvalue(userid, "name", unicode(value))
		else:
			es.cexec(userid, "name %s" % unicode(value))
def near(variable, users, distance, baseuser, command):
	vec = es.getplayerprop(baseuser, "CBaseEntity.m_vecOrigin").split(",")
	nearcoord(variable, users, distance, float(vec[0]), float(vec[1]), float(vec[2]), command)
def nearcoord(variable, users, distance, x, y, z, command):
	filter = getusers(users)
	players = playerlib.nearCoord((float(x), float(y), float(z)), float(distance))
	for player in players:
		userid = player.userid
		if userid in filter:
			es.ServerCommand("es_set %s %s" % (variable, userid))
			es.ServerCommand(command)
def noclip(users, value):
	if int(value) == 1:
		v = 1
	else:
		v = 0
	for userid in getusers(users):
		playerlib.getPlayer(userid).noclip(v)
def openfile(flags, path):
	global file_list
	global file_handle
	if not flags in ("r", "w"): return
	test = os.getcwd() + "/cstrike/" + path
	if fileexists(test) != 1:
		return
	file = open(test)
	try:
		file_handle += 1
		file_list[file_handle] = [flags, test, file.readlines()]
		return file_handle
	finally:
		if file: file.close()
def physpush(users, x, y, z):
	for userid in getusers(users):
		xx = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[0]")
		yy = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[1]")
		zz = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[2]")
		vec = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecBaseVelocity").split(",")
		es.setplayerprop(userid, "CBasePlayer.localdata.m_vecBaseVelocity", "%f,%f,%f" % (float(x) + float(vec[0]) - xx, float(y) + float(vec[1]) - yy, float(z) + float(vec[2]) - zz))
def play(users, param, duration = 0, volume = 1.0):
	d = float(duration)
	v = float(volume)
	for userid in getusers(users):
		es.playsound(userid, param, v)
	if d != 0:
		gamethread.delayed(d, stopsound, (userid, param))
def playedict(index, param, volume = 1.0, attenuation = 0.5):
	v = float(volume)
	a = float(attenuation)
	es.emitsound("entity", int(index), param, v, a)
def playercount(users):
	return len(getusers(users))
def playplayer(users, param, volume = 1.0, attenuation = 0.5):
	v = float(volume)
	a = float(attenuation)
	for userid in getusers(users):
		es.emitsound("player", userid, param, v, a)
def pushto(users, x, y, z, force):
	target = (float(x), float(y), float(z))
	f = float(force)
	for userid in getusers(users):
		xx = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[0]")
		yy = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[1]")
		zz = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[2]")
		source = es.getindexprop(index, "CBaseEntity.m_vecOrigin").split(",")
		base = (target[0] - float(source[0]), target[1] - float(source[1]), tartget[2] - float(source[2]))
		es.setplayerprop(userid, "CBasePlayer.localdata.m_vecBaseVelocity", "%f,%f,%f" % (base[0] * f - xx, base[1] * f - yy, base[2] * f - zz))
def randplayer(users):
	players = getusers(users)
	max = len(players)
	if max > 0:
		no = random.randint(0, max - 1)
		count = 0
		for item in players:
			if count == no:
				return item
			count += 1
	return None
def regclientcmd(command, type):
	global regclientcmd_list
	if str(type) == "1":
		t = 1
	else:
		t = 0
	for item in regclientcmd_list:
		if item[0] == command:
			regclientcmd_list.remove(item)
			break
	regclientcmd_list.append([command, t])
def regeventblock(eventname, code):
	global regeventblock_list
	if eventname in regeventblock_list:
		return
	regeventblock_list[eventname] = code
	spe.registerPreHook(eventname, hooked)
def regsayhook(text, ispartial):
	global sayhook_list
	sayhook_list[text] = int(ispartial)
def remove(param):
	es.fire(gettrigger(), str(param), "Kill")
def removeidle(param):
	if param == "weapon":
		global allweapons
		for weapon in allweapons:
			removeidle(weapon)
		return
	weapon = es.createentitylist(param)
	for index in weapon:
		if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") == -1:
			es.setentityname(index, "theweapon")
	es.fire(gettrigger(), "theweapon", "Kill")
def removeweapon(users, param):
	for userid in getusers(users):
		info = getweaponinfo(userid, param, 1)
		active = es.getindexfromhandle(es.getplayerprop(userid, "CBaseCombatCharacter.m_hActiveWeapon"))
		for index in info:
			es.setentityname(index, "theweapon")
			if index == active:
				es.cexec(userid, "lastinv")
	es.fire(gettrigger(), "theweapon", "Kill")
def rescued():
	global count_rescued
	return count_rescued
def restrict(users, param):
	if str(param) in ("1", "2", "3", "4"):
		return
	if str(param) == "mp5":
		param = "mp5navy"
	item = "weapon_%s" % param
	global allweapons
	if not item in allweapons:
		return
	global restrict_list
	for userid in getusers(users):
		if not item in restrict_list[userid]:
			restrict_list[userid].append(item)
			removeweapon(userid, item)
def restrictall(users):
	global restrict_list
	global allweapons
	for userid in getusers(users):
		restrict_list[userid] = allweapons
def rocket(users):
	global rocket_list
	global round_count
	es.precachemodel("sprites/muzzleflash1.vmt")
	god(users, 0)
	shake(users, 10, 40, 25)
	for userid in getusers(users):
		dead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
		if dead:
			continue
		rocket_list[int(userid)] = 1
		es.emitsound("player", userid, "weapons/rpg/rocketfire1.wav", 0.5, 0.5)
		gamethread.delayed(1, es.emitsound, ("player", userid, "weapons/rpg/rocket1.wav", 0.5, 0.5))
		height = float(es.getplayerprop(userid, "CBaseEntity.m_vecOrigin").split(",")[2])
		gamethread.delayed(1, rocket_loop, (userid, 0, height, height, int(round_count)))
def rocket_loop(userid, count, height, oldheight, round):
	global rocket_list
	global restrict_list
	global round_count
	global round_interval
	trigger = gettrigger()
	if round != round_count and round_interval == 0:
		return
	if not int(userid) in rocket_list:
		return
	dead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
	if dead:
		es.stopsound(userid, "weapons/rpg/rocket1.wav")
		rocket_list[int(userid)] = 0
		return
	physpush(userid, 0, 0, 350)
	vec = [float(x) for x in es.getplayerprop(userid, "CBaseEntity.m_vecOrigin").split(",")]
	if vec[2] >= (height + 10) or count < 14:
		gamethread.delayed(0.1, rocket_loop, (userid, count + 1, vec[2], height, round))
		index = es.createentity("env_sprite")
		es.setindexprop(index, "CBaseEntity.m_vecOrigin", "%f,%f,%f" % (vec[0], vec[1], vec[2]))
		es.entitysetvalue(index, "model", "sprites/muzzleflash1.vmt")
		es.entitysetvalue(index, "scale", 0.25)
		es.entitysetvalue(index, "rendermode", 1)
		es.entitysetvalue(index, "renderamt", 220)
		es.spawnentity(index)
		es.setentityname(index, index)
		es.fire(trigger, index, "ShowSprite")
		gamethread.delayed(0.05, es.entitysetvalue, (index, "scale", 0.20))
		gamethread.delayed(0.05, es.setindexprop, (index, "CBaseEntity.m_vecOrigin", "%f,%f,%f" % (vec[0], vec[1], vec[2]-50)))
		gamethread.delayed(0.05, es.entitysetvalue, (index, "renderamt", 200))
		gamethread.delayed(0.1, es.entitysetvalue, (index, "scale", 0.15))
		gamethread.delayed(0.1, es.setindexprop, (index, "CBaseEntity.m_vecOrigin", "%f,%f,%f" % (vec[0], vec[1], vec[2]-100)))
		gamethread.delayed(0.05, es.entitysetvalue, (index, "renderamt", 180))
		gamethread.delayed(0.15, es.entitysetvalue, (index, "scale", 0.10))
		gamethread.delayed(0.15, es.setindexprop, (index, "CBaseEntity.m_vecOrigin", "%f,%f,%f" % (vec[0], vec[1], vec[2]-150)))
		gamethread.delayed(0.05, es.entitysetvalue, (index, "renderamt", 160))
		gamethread.delayed(0.2, es.fire, (trigger, index, "Kill"))
		return
	es.stopsound(userid, "weapons/rpg/rocket1.wav")
	rocket_list[int(userid)] = 0
	es.emitsound("player", userid, "weapons/hegrenade/explode3.wav", 0.5, 0.5)
	index = es.createentity("env_explosion")
	es.spawnentity(index)
	es.setentityname(index, "theexplosion")
	es.fire(trigger, "theexplosion", "addoutput", "origin %f %f %f" % (vec[0], vec[1], vec[2] + 36))
	es.fire(trigger, "theexplosion", "addoutput", "iRadiusOverride 100")
	es.fire(trigger, "theexplosion", "addoutput", "iMagnitude 1000")
	es.fire(trigger, "theexplosion", "Explode")
	es.fire(trigger, "theexplosion", "Kill")
	slay(userid)
def rounddecimal(value, places):
	v = round(float(value), int(places))
	if places == "0":
		return str(int(v))
	return str(v)
def setaim(source, target, value):
	sourceid = 0
	for userid in getusers(source):
		sourceid = userid
		break
	targetid = 0
	for userid in getusers(target):
		targetid = userid
		break
	if sourceid == 0 or targetid == 0:
		return
	player = playerlib.getPlayer(sourceid)
	player.viewPlayer(targetid)
def setammo(users, param, value):
	global ammo_list
	for userid in getusers(users):
		info = getweaponinfo(userid, param)
		for name in info:
			no = ammo_list[name]
			es.setplayerprop(userid, "CBasePlayer.localdata.m_iAmmo.%s" % no, int(value))
def setarmor(users, value):
	armor(users, "=", value)
def setcash(users, value):
	cash(users, "=", value)
def setclipammo(users, param, value):
	for userid in getusers(users):
		info = getweaponinfo(userid, param, 1)
		if info == []:
			continue
		for index in info:
			es.setindexprop(index, "CBaseCombatWeapon.LocalWeaponData.m_iClip1", int(value))
def setentitycolor(index, r, g, b, a):
	color = int(r) + (int(g) << 8) + (int(b) << 16) + (int(a) << 24)
	if color >= 2**31: color -= 2**32
	es.setindexprop(index, "CBaseEntity.m_nRenderMode", es.getindexprop(index, "CBaseEntity.m_nRenderMode") | 1)
	es.setindexprop(index, "CBaseEntity.m_nRenderFX", es.getindexprop(index, "CBaseEntity.m_nRenderFX") | 256)
	es.setindexprop(index, "CBaseEntity.m_clrRender", color)
def setentmodel(index, model):
	model = model.replace("\\", "/")
	if not model.startswith("models/"):
		model = "models/" + model
	if not model.endswith(".mdl"):
		model += ".mdl"
	es.entitysetvalue(index, "modelindex", es.precachemodel(model))
def setentname(index, param):
	global entname_list
	entname_list[index] = param
	es.setentityname(index, param)
def setgravity(users, ratio):
	for userid in getusers(users):
		index = es.getindexfromhandle(es.getplayerhandle(userid))
		es.entitysetvalue(index, "gravity", float(ratio))
def sethealth(users, value):
	health(users, "=", value)
def setmodel(users, model):
	model = model.replace("\\", "/")
	if not model.startswith("models/"):
		model = "models/" + model
	if not model.endswith(".mdl"):
		model += ".mdl"
	m = es.precachemodel(model)
	for userid in getusers(users):
		index = es.getindexfromhandle(es.getplayerhandle(userid))
		es.entitysetvalue(index, "modelindex", m)
def setplayercolor(users, r, g, b, a, weapon):
	if str(weapon) == "1":
		w = 1
	else:
		w = 0
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		player.setColor(int(r), int(g), int(b), int(a))
		if w == 1 and player.weapon != None:
			player.setWeaponColor(int(r), int(g), int(b), int(a))
def setviewangle(users, pitch, yaw, roll):
	for userid in getusers(users):
		es.setang(userid, pitch, yaw, roll)
def setviewcoord(users, x, y, z):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		pos = [x, y, z]
		player.viewCoord(pos)
def shake(users, time, distance, value):
	es.usermsg("create", "shake", "Shake")
	es.usermsg("write", "byte", "shake", 0)
	es.usermsg("write", "float", "shake", float(value))
	es.usermsg("write", "float", "shake", float(distance))
	es.usermsg("write", "float", "shake", float(time))
	for userid in getusers(users):
		es.usermsg("send", "shake", userid)
	es.usermsg("delete", "shake")
def showmenu(time, users, text):
	count = int(int(time) / 3)
	diff = int(int(time) % 3)
	users_list = getusers(users)
	no = 0
	while count > 0:
		gamethread.delayed(no * 3, showmenu_loop, (3, users_list, text))
		no += 1
		count -= 1
	gamethread.delayed(no * 3, showmenu_loop, (diff, users_list, text))
def showmenu_loop(time, users_list, text):
	for userid in users_list:
		es.showMenu(time, userid, text)
def slay(users):
	damage(0, users, 10000)
	gamethread.delayed(0.1, slay_delayed, users)
def slay_delayed(users):
	for userid in getusers(users):
		es.ServerCommand("es_sexec %d kill" % int(userid))
def spawn(users, param = 0):
	gamethread.delayed(0.15, spawn_delayed, (users, param))
def spawn_delayed(users, param):
	if param == "1":
		p = 1
	else:
		p = 0
	global spawn_restrict
	for userid in getusers(users):
		if not es.getplayerprop(userid, "CBaseEntity.m_iTeamNum") in [2, 3]:
			continue
		if p:
			spe.respawn(userid)
		else:
			es.ServerCommand("es_xsetplayerprop %s CBasePlayer.m_lifeState 512" % userid)
			es.ServerCommand("es_xsetplayerprop %s CCSPlayer.m_iPlayerState 0" % userid)
			es.ServerCommand("es_xspawnplayer %s" % userid)
def speed(users, value):
	for userid in getusers(users):
		es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", value)
def stopsound(users, param):
	for userid in getusers(users):
		es.stopsound(userid, param)
def stripplayer(users, param = 0):
	trigger = gettrigger()
	index = es.createentity("player_weaponstrip")
	es.setentityname(index, "thestrip")
	for userid in getusers(users):
		if str(param) != "0":
			es.fire(userid, "thestrip", "StripWeaponsAndSuit")
		else:
			es.fire(userid, "thestrip", "Strip")
	es.fire(trigger, "thestrip", "Kill")
def strlen(param):
	return len(param)
def strtolower(param):
	return param.lower()
def strtoupper(param):
	return param.upper()
def team(users, no):
	if not str(no) in ["0", "1", "2", "3"]:
		return
	n = int(no)
	trigger = gettrigger()
	temp = getusers(users)
	if n > 1:
		for userid in temp:
			spe.switchTeam(userid, n)
	else:
		for userid in temp:
			index = es.getindexfromhandle(es.getplayerhandle(userid))
			es.entitysetvalue(index, "targetname", index)
			es.ServerCommand("es_xfire %d %d SetTeam %d" % (trigger, index, n))
def teleport(users, x, y, z):
	for userid in getusers(users):
		es.setpos(userid, float(x), float(y), float(z))
def trimdecimal(value, places):
	v = str(float(value))
	p = int(places)
	if p == 0:
		return v[0]
	return v[:p + 2]
def unregclientcmd(command):
	global regclientcmd_list
	if [command, 0] in regclientcmd_list:
		regclientcmd_list.remove([command, 0])
	if [command, 1] in regclientcmd_list:
		regclientcmd_list.remove([command, 1])
def unregeventblock(eventname, code = ""):
	global regeventblock_list
	if not eventname in regeventblock_list:
		return
	del regeventblock_list[eventname]
	spe.unregisterPreHook(eventname, hooked)
def unregsayhook(text):
	global sayhook_list
	if text in sayhook_list:
		del sayhook_list[text]
def unrestrict(users, param):
	if str(param) in ("1", "2", "3", "4"):
		return
	if str(param) == "mp5":
		param = "mp5navy"
	item = "weapon_%s" % param
	global allweapons
	if not item in allweapons:
		return
	global restrict_list
	for userid in getusers(users):
		if not userid in restrict_list:
			continue
		if item in restrict_list[userid]:
			restrict_list[userid].remove(item)
def unrestrictall(users):
	global restrict_list
	for userid in getusers(users):
		if not userid in restrict_list:
			continue
		restrict_list[userid] = []
def uptime():
	global starttime
	return time.time() - starttime

def es_player_chat(event_var):
	userid = event_var["userid"]
	text = event_var["text"]
	if int(userid) <= 0:
		return
	if es.exists("saycommand", text):
		return
	team = es.getplayerprop(userid, "CBaseEntity.m_iTeamNum")
	type = type = "#Cstrike_Chat_AllDead"
	if team in [0, 1]:
		if not int(event_var["teamonly"]):
			players = "#alive"
			type = "#Cstrike_Chat_AllSpec"
			flag = 1
	elif es.getplayerprop(userid, "CBasePlayer.pl.deadflag") == 1:
		if int(event_var["teamonly"]):
			if team == 2:
				str = "#t,#alive"
				type = "#Cstrike_Chat_T_Dead"
			if team == 3:
				str = "#ct,#alive"
				type = "#Cstrike_Chat_CT_Dead"
			players = str
		else:
			players = "#alive"
			type = "#Cstrike_Chat_AllDead"
	else:
		return
	gamethread.delayed(0, es_player_chat_delayed, (userid, type, name, text, players))

def es_player_chat_delayed(userid, type, name, text, players):
	name = es.getplayername(userid)
	es.usermsg('create', 'deadchat', 'SayText2')
	es.usermsg('write', 'byte', 'deadchat', es.getindexfromhandle(es.getplayerhandle(userid)))
	es.usermsg('write', 'byte', 'deadchat', 1)
	es.usermsg('write', 'string', 'deadchat', type)
	es.usermsg('write', 'string', 'deadchat', unicode(name))
	es.usermsg('write', 'string', 'deadchat', unicode(text))
	for userid in playerlib.getUseridList(players):
		es.usermsg('send', 'deadchat', userid)
	es.usermsg('delete', 'deadchat')

def player_connect(event_var):
	global restrict_list
	global deaths_list
	global rocket_list
	global escort_list
	global getchat_list
	global thetrigger
	global curtimed
	if curtimed == 0:
		curtimed = 1
		curtime_init()
	userid = int(event_var["userid"])
	restrict_list[userid] = []
	deaths_list[userid] = 0
	rocket_list[userid] = 0
	escort_list[userid] = 0
	getchat_list[userid] = ""
	es.server.mp_disable_autokick(userid)
	if es.getplayersteamid(userid) != "BOT" and thetrigger == 0:
		thetrigger = userid

def player_activate(event_var):
	es.server.mp_disable_autokick(event_var["userid"])

def pre_player_disconnect(event_var):
	global thetrigger
	global rocket_list
	userid = int(event_var["userid"])
	if thetrigger == userid:
		thetrigger = 0
	if userid in rocket_list:
		if rocket_list[userid] == 1:
			es.stopsound(userid, "weapons/rpg/rocket1.wav")

def player_disconnect(event_var):
	global restrict_list
	global deaths_list
	global rocket_list
	global escort_list
	global getchat_list
	userid = int(event_var["userid"])
	del restrict_list[userid]
	del deaths_list[userid]
	del rocket_list[userid]
	del escort_list[userid]
	del getchat_list[userid]

def pre_weapon_fire(event_var):
	if es.ServerVar("est_enable_weapon_mods") == 0:
		return
	userid = int(event_var["userid"])
	item = "weapon_%s" % event_var["weapon"]
	if item == "weapon_mp5":
		item = "weapon_mp5navy"
	global weaponmod_list
	if item in weaponmod_list:
		temp_dic = weaponmod_list[item]
		auto = temp_dic["auto"]
		if auto == "0":
			return
		gamethread.delayed(0, es.setplayerprop, (userid, "CCSPlayer.cslocaldata.m_iShotsFired", 0))

def weapon_fire(event_var):
	if es.ServerVar("est_enable_weapon_mods") == 0:
		return
	userid = int(event_var["userid"])
	item = "weapon_%s" % event_var["weapon"]
	if item == "weapon_mp5":
		item = "weapon_mp5navy"
	global weaponmod_list
	if item in weaponmod_list:
		temp_dic = weaponmod_list[item]
		recoil = temp_dic["recoil"]
		if recoil == "0":
			return
		vec = [float(x) for x in es.getplayerprop(userid, "CBasePlayer.localdata.m_Local.m_vecPunchAngle").split(",")]
		v = float(recoil) * -0.1
		temp = "%f,%f,%f" % (v, vec[1], vec[2])
		es.setplayerprop(userid, "CBasePlayer.localdata.m_Local.m_vecPunchAngle", temp)

def pre_player_hurt(event_var):
	if es.ServerVar("est_enable_weapon_mods") == 0:
		return
	userid = int(event_var["userid"])
	attacker = int(event_var["attacker"])
	if attacker == 0 or userid == 0:
		return
	item = "weapon_%s" % event_var["weapon"]
	if item == "weapon_mp5":
		item = "weapon_mp5navy"
	global modplayerweapon_list
	global modweapon_list
	global weaponmod_list
	flag = 0
	if item in weaponmod_list:
		temp_dic = weaponmod_list[item]
		action = temp_dic["damageaction"]
		if not action in ("=", "+", "*"):
			return
		param = "damage%d" % event_var["hitgroup"]
		if action == "=":
			point = int(temp_dic[param])
		if action == "+":
			point = event_var["dmg_health"] + int(temp_dic[param])
		if action == "*":
			point = event_var["dmg_health"] * int(temp_dic[param])
		flag = 1
	elif attacker in modplayerweapon_list:
		mods = modplayerweapon_list[attacker]
		for mod in mods:
			if mod[0] == item:
				point = mod[1]
				flag = 1
				break
	elif item in modweapon_list:
		point = modweapon_list[item]
		flag = 1
	if flag == 0:
		return
	health = es.getplayerprop(userid, "CBasePlayer.m_iHealth")
	if event_var["dmg_health"] != point:
		es.setplayerprop(userid, "CBasePlayer.m_iHealth", health + event_var["dmg_health"])
		damage(attacker, userid, point)

def player_death(event_var):
	global deaths_list
	userid = int(event_var["userid"])
	deaths_list[userid] += 1

def pre_item_pickup(event_var):
	global bought_list
	userid = event_var["userid"]
	item = event_var["item"]
	cash = es.getplayerprop(userid, "CCSPlayer.m_iAccount")
	key = "%s,%s" % (userid, item)
	bought_list[key] = cash

def item_pickup(event_var):
	global bought_list
	userid = event_var["userid"]
	item = event_var["item"]
	cash = es.getplayerprop(userid, "CCSPlayer.m_iAccount")
	key = "%s,%s" % (userid, item)
	change = 0
	if bought_list[key] != cash:
		change = 1
	result = item_pickup_restrict(event_var)
	if change == 1:
		es.event("initialize", "est_playerbought")
		es.event("setint", "est_playerbought", "userid", userid)
		es.event("setstring", "est_playerbought", "item", item)
		es.event("setint", "est_playerbought", "restricted", result)
		es.event("fire", "est_playerbought")

def item_pickup_restrict(event_var):
	# we have to think about autobuy and rebuy
	weapon_restrictions = es.ServerVar("est_enable_weapon_restrictions")
	if not weapon_restrictions:
		return 0
	userid = int(event_var["userid"])
	item = "weapon_%s" % event_var["item"]
	if item == "weapon_mp5":
		item = "weapon_mp5navy"
	global allweapons
	if not item in allweapons:
		return 0
	global restrict_list
	restricts = restrict_list[userid]
	if item in restricts:
		removeweapon(userid, item)
		return 1
	return 0

def es_map_start(event_var):
	global round_count
	global round_interval
	global cs_player_manager
	round_count = 0
	round_interval = 0
	cs_player_manager = es.getentityindex("cs_player_manager")
	global regclientcmd_list, restrict_list, modplayerweapon_list, modweapon_list, weaponmod_list, modified_deaths, deaths_list, regeventblock_list, rocket_list, escort_list, bought_list, sayhook_list, getchat_list, entname_list, count_rescued
	regclientcmd_list = []
	modplayerweapon_list = {}
	modweapon_list = {}
	weaponmod_list = {}
	modified_deaths = 0
	regeventblock_list = {}
	bought_list = {}
	sayhook_list = {}
	entname_list = {}
	count_rescued = 0
	for key in restrict_list:
		restrict_list[key] = []
	for key in deaths_list:
		deaths_list[key] = 0
	for key in rocket_list:
		rocket_list[key] = 0
	for key in escort_list:
		escort_list[key] = 0
	for key in getchat_list:
		getchat_list[key] = ""
	curtime_init()

def round_start(event_var):
	global timer
	global round_interval
	global count_rescued
	global escort_list
	for item in escort_list:
		escort_list[item] = 0
	count_rescued = 0
	drug("#all", 0)
	round_interval = 0

def round_end(event_var):
	global round_count
	global round_interval
	round_count += 1
	round_interval = 1

def hostage_follows(event_var):
	global escort_list
	userid = int(event_var["userid"])
	escort_list[userid] += 1

def hostage_stops_following(event_var):
	global escort_list
	userid = int(event_var["userid"])
	escort_list[userid] -= 1

def hostage_rescued(event_var):
	global count_rescued
	global escort_list
	userid = int(event_var["userid"])
	count_rescued += 1
	escort_list[userid] -= 1

def hooked(event_var):
	global hooked_event_var
	global regeventblock_list
	eventname = event_var["spe_eventname"]
	hooked_event_var = event_var
	es.ServerCommand(regeventblock_list[eventname])

def sayfilter(userid, text, teamonly):
	global sayhook_list
	global getchat_list
	flag = 0
	rawtext = text.strip('"')
	getchat_list[userid] = rawtext
	for item in sayhook_list:
		partial = sayhook_list[item]
		if partial == 0:
			if item == rawtext:
				flag = 1
				break
		else:
			if item in rawtext:
				flag = 1
				break
	if flag == 1:
		es.event("initialize", "est_sayhook")
		es.event("setint", "est_sayhook", "userid", userid)
		es.event("setstring", "est_sayhook", "hooktext", item)
		es.event("setstring", "est_sayhook", "commandstring", text)
		es.event("setstring", "est_sayhook", "teamchat", teamonly)
		es.event("fire", "est_sayhook")
		return (0, 0, 0)
	return (userid, text, teamonly)

def clientcommandfilter(userid, args):
	global regclientcmd_list
	global restrict_list
	advanceddrop = es.ServerVar("est_allowadvanceddrop")
	weapon_restrictions = es.ServerVar("est_enable_weapon_restrictions")
	cmd = args[0].lower()
	flag = 0
	if weapon_restrictions:
		if advanceddrop and cmd == "drop" and not "drop" in regclientcmd_list:
			flag = 1
	else:
		if advanceddrop and cmd == "drop":
			flag = 1
	if flag == 1:
		gun = getgun(userid)
		if gun in ["weapon_knife", "weapon_hegrenade", "weapon_flashbang", "weapon_smokegrenade"]:
			spe.dropWeapon(userid, gun)
			return False
	if cmd == "buy" and es.getplayerprop(userid, "CCSPlayer.m_bInBuyZone") and len(args) > 1 and weapon_restrictions:
		restricts = restrict_list[userid]
		item = "weapon_%s" % args[1].lower()
		if item == "weapon_mp5":
			item = "weapon_mp5navy"
		if item in restricts:
			es.playsound(userid, "buttons/weapon_cant_buy.wav", 1.0)
			return False
	for item in regclientcmd_list:
		if item[0] == cmd:
			es.event("initialize", "est_cmdhook")
			es.event("setint", "est_cmdhook", "userid", userid)
			es.event("setstring", "est_cmdhook", "hooktext", args[0])
			if len(args) > 1:
				es.event("setstring", "est_cmdhook", "commandstring", args[1])
			else:
				es.event("setstring", "est_cmdhook", "commandstring", "")
			es.event("fire", "est_cmdhook")
			if int(item[1]) != 0: return True
			else: return False
	return True

def getweaponinfo(userid, param, getindex=0):
	if str(param) in ("1", "2", "3", "4"):
		if getindex == 1:
			return getweaponinfo2(userid, param, 1)
		return getweaponinfo2(userid, param, 0)
	v = ""
	if param.startswith("weapon_"):
		v = param
	else:
		if param == "mp5":
			param = "mp5navy"
		if param == "":
			v == "weapon_none"
		else:
			v = "weapon_%s" % param
	if getindex == 0:
		return [v]
	no = 0
	while no < 48:
		handle = es.getplayerprop(userid, "CBaseCombatCharacter.m_hMyWeapons.%.3d" % no)
		no += 1
		if handle == -1:
			continue
		index = es.getindexfromhandle(handle)
		name = es.entitygetvalue(index, "classname")
		if name == v:
			return [index]
	return []

def getweaponinfo2(userid, param, getindex):
	global allprimary
	global allsecondary
	p = int(param)
	he = sg = fb = 0
	nades = []
	no = 0
	while no < 48:
		handle = es.getplayerprop(userid, "CBaseCombatCharacter.m_hMyWeapons.%.3d" % no)
		no += 1
		if handle == -1:
			continue
		index = es.getindexfromhandle(handle)
		name = es.entitygetvalue(index, "classname")
		if getindex == 1:
			v = index
		else:
			v = name
		if p == 1 and name in allprimary:
			return [v]
		if p == 2 and name in allsecondary:
			return [v]
		if p == 3 and name == "weapon_knife":
			return [v]
		if p == 4:
			if getindex == 0:
				if name == "weapon_hegrenade":
					he = 1
				if name == "weapon_smokegrenade":
					sg = 1
				if name == "weapon_flashbang":
					fb = 1
			else:
				if name in ("weapon_hegrenade", "weapon_smokegrenade", "weapon_flashbang"):
					nades.append(index)
	if p == 4:
		if getindex == 0:
			if he: nades.append("weapon_hegrenade")
			if sg: nades.append("weapon_smokegrenade")
			if fb: nades.append("weapon_flashbang")
		if nades == []:
			return ["weapon_none"]
		return nades
	if getindex == 1:
		return []
	return ["weapon_none"]

def getusers(users):
	# http://www.eventscripts.com/pages/Est_PlayerSelection
	# Python style #alive, #all, #bot, #ct, #dead, #human, #spec, #t, #un
	# EST style #a, #c, #3, #t, #2, #s, #1, #u, #0, #h, #b, #l, #d
	# ex1: #alive,#ct (for CT who is alive)
	# ex2: #23!d (for all T and CT who is alive)
	# issue: names start with # are not supported
	global pyfilter
	if str(users).startswith("#"):
		status = 0
		notfilter = ""
		if "," in users:
			status = 1
		if "!" in users:
			all = users.split("!")
			users = all[0]
			notfilter = all[1]
			status = 2
		if status == 0:
			if users in pyfilter:
				status = 1
			else:
				status = 2
		if status == 2:
			global filter_table
			filter = []
			for item in filter_table:
				if item[0] in users:
					idlist = playerlib.getUseridList(item[1])
					filter.extend(idlist)
			users = set(filter)
			if notfilter != "":
				filter = []
				for item in filter_table:
					if item[0] in notfilter:
						idlist = playerlib.getUseridList(item[1])
						filter.extend(idlist)
				notfilter = set(filter)
				for item in notfilter:
					if int(item) in users:
						users.remove(int(item))
		else:
			users = playerlib.getUseridList(users)
	else:
		test = []
		if isinstance(users, tuple) or isinstance(users, list):
			test = users
		else:
			test.append(users)
		users = []
		for user in test:
			users.append(es.getuserid(user))
	return users

def estfilter(users):
	if not str(users).startswith("#"):
		return users
	users = users.replace("t", "2")
	users = users.replace("c", "3")
	return users

def unicode(text):
	# for unicode texts in usermsg
	status = 0
	error = ":; ()'"
	for item in error:
		if item in text:
			status = 1
			break
	if status:
		msg = text
	else:
		msg = '"' + text + '"'
	return msg

def gettrigger():
	global thetrigger
	if thetrigger != 0:
		return thetrigger
	for userid in es.getUseridList():
		if es.getplayersteamid(userid) != "BOT":
			return userid
	return userid

def ticklistener():
	global modified_deaths
	if modified_deaths != 0:
		global deaths_list
		for userid in es.getUseridList():
			if not userid in deaths_list:
				continue
			index = es.getindexfromhandle(es.getplayerhandle(userid))
			es.setindexprop(cs_player_manager, "CPlayerResource.m_iDeaths.%.3d" % index, deaths_list[userid])